<?php

/*
 * This script generates the pdf. 
 * PDF generation needs time, so we write first a message, that the pdf creation is in work. This text must be flushed!
 * Then we create the pdf and after that we write a message, that the pdf is generated.
 *
 * We need no phpBB template system, because the output is done in a new small window and we must flush the outputs!
 */

define('IN_PHPBB', true);
$phpbb_root_path = './';
include($phpbb_root_path . 'extension.inc');
include($phpbb_root_path . 'common.'.$phpEx);
include($phpbb_root_path . 'includes/bbcode.'.$phpEx);
include($phpbb_root_path . 'includes/functions_validate.'.$phpEx);
include($phpbb_root_path . 'pdf24API.'.$phpEx);

//send content type header and set charset
header('content-type: text/html; charset=' . $lang['ENCODING']);

//
// Start session management
//
$userdata = session_pagestart($user_ip, PAGE_INDEX);
init_userprefs($userdata);
//
// End session management
//

//get post order
$post_time_order = 'ASC';
if ( !empty($HTTP_POST_VARS['post_order']) )
{
	$post_order = strtoupper($HTTP_POST_VARS['post_order']);
	$post_time_order = ($post_order == 'ASC') ? 'ASC' : 'DESC';
}

$start = empty($HTTP_POST_VARS['start']) ? 0 : intval($HTTP_POST_VARS['start']);

$postDays = 0;
$limit_posts_time = '';

if ( !empty($HTTP_POST_VARS['post_days']) )
{
	$postDays = intval($HTTP_POST_VARS['post_days']);
	$min_post_time = time() - ($postDays * 86400);
	$limit_posts_time = "AND p.post_time >= $min_post_time ";
}

$topicId = empty($HTTP_POST_VARS['topic_id']) ? 0 : intval($HTTP_POST_VARS['topic_id']);

//get and validate email
$email = '';
if ( !empty($HTTP_POST_VARS['email']) )
{	
	$email = trim($HTTP_POST_VARS['email']);
}
$emailValidate = validate_email($email);
if($emailValidate['error'])
{
	echo '<html><body><b>'.$emailValidate['error_msg'].'</b></body></html>';
	exit;
}

$script_path = preg_replace('/^\/?(.*?)\/?$/', '\\1', trim($board_config['script_path']));
$server_name = trim($board_config['server_name']);
$server_protocol = ( $board_config['cookie_secure'] ) ? 'https://' : 'http://';
$server_port = ( $board_config['server_port'] <> 80 ) ? ':' . trim($board_config['server_port']) . '/' : '/';
$forumUrl = $server_protocol . $server_name . $server_port . $script_path . '/';

//we must flush outputs, so phpBB template system can't be used
echo '<html><title>'.$lang['Create_PDF'].'</title><body>';
echo '<body>'.$lang['Creating_PDF_now'].'<br /><br />';

$spaces = 250;
ob_start(); //activate buffer, because we send a lot of spaces
while(--$spaces > 0)
{
	echo '  ';
}
echo "\r\n";
ob_end_flush();
flush();

$sql = "SELECT topic_title
		FROM " . TOPICS_TABLE . "
		WHERE topic_id = $topicId";	
$result = $db->sql_query($sql);
$topic_data = $db->sql_fetchrow($result);

if(!$topic_data)
{
	echo $lang['Topic_not_valid'];
	exit;
}		
		
if ( !($result = $db->sql_query($sql)) )
{
	message_die(GENERAL_ERROR, 'query error', '', __LINE__, __FILE__, $sql);
}

$sql = "SELECT u.username, p.*,  pt.post_text, pt.post_subject, pt.bbcode_uid
		FROM " . POSTS_TABLE . " p, " . USERS_TABLE . " u, " . POSTS_TEXT_TABLE . " pt
		WHERE p.topic_id = $topicId
		$limit_posts_time
		AND pt.post_id = p.post_id
		AND u.user_id = p.poster_id
		ORDER BY p.post_time $post_time_order
		LIMIT $start, ".$board_config["posts_per_page"];		
		
if ( !($result = $db->sql_query($sql)) )
{
	message_die(GENERAL_ERROR, 'query error', '', __LINE__, __FILE__, $sql);
}
$total_posts = 0;
$postrows = array();
while ($row = $db->sql_fetchrow($result))
{
	$total_posts++;
	$postrows[] = $row;
}
$db->sql_freeresult($result);

$nameSearchArr = array('/','\\','*','?','<','>','|');
$pdfFileName = $board_config['sitename'] . ' - ' . $topic_data['topic_title'];
$pdfFileName = str_replace($nameSearchArr, '_', $pdfFileName);

//build document
$doc = new PDF24Doc();
$doc->addTo($email);
$doc->setHeadline($board_config['sitename']);
$doc->setBaseUrl($forumUrl);
$doc->setHeadlineUrl($forumUrl);
$doc->setFrom($board_config['board_email']);
$doc->setCharset($lang['ENCODING']);
$doc->setPdfFileName($pdfFileName);

foreach($postrows as $row) 
{
	$bbcode_uid = $row['bbcode_uid'];
	$text = $row['post_text'];
	$title = $row['post_subject'];
	$titleUrl = $forumUrl . 'viewtopic.php?'.POST_TOPIC_URL.'='.$row['topic_id'].'&'.POST_FORUM_URL.'='.$row['forum_id'].'#'.$row['post_id'];
	$author = $row['username'];
	$timeStamp = date('d.m.Y h:m:s', $row['post_time']);
	
	if ($bbcode_uid != '')
	{
		$text = ($board_config['allow_bbcode']) ? bbencode_second_pass($text, $bbcode_uid) : preg_replace('/\:$bbcode_uid/si', '', $text);
	}
	if ( $board_config['allow_smilies'] )
	{
		$text = smilies_pass($text);
	}
	$text = str_replace("\n", "\n<br />\n", $text);
	$doc->addPart($text, $title, $titleUrl, $author, $timestamp);	
}
$res = $doc->createAndSend();

echo $lang['PDF_created_and_sent'];
echo '</body></html>';


?>